/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/googleapis/google-api-java-client-services/
 * Modify at your own risk.
 */

package com.google.api.services.sheets.v4.model;

/**
 * Appends rows or columns to the end of a sheet.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Sheets API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class AppendDimensionRequest extends com.google.api.client.json.GenericJson {

  /**
   * Whether rows or columns should be appended.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String dimension;

  /**
   * The number of rows or columns to append.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer length;

  /**
   * The sheet to append rows or columns to.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer sheetId;

  /**
   * Whether rows or columns should be appended.
   * @return value or {@code null} for none
   */
  public java.lang.String getDimension() {
    return dimension;
  }

  /**
   * Whether rows or columns should be appended.
   * @param dimension dimension or {@code null} for none
   */
  public AppendDimensionRequest setDimension(java.lang.String dimension) {
    this.dimension = dimension;
    return this;
  }

  /**
   * The number of rows or columns to append.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getLength() {
    return length;
  }

  /**
   * The number of rows or columns to append.
   * @param length length or {@code null} for none
   */
  public AppendDimensionRequest setLength(java.lang.Integer length) {
    this.length = length;
    return this;
  }

  /**
   * The sheet to append rows or columns to.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getSheetId() {
    return sheetId;
  }

  /**
   * The sheet to append rows or columns to.
   * @param sheetId sheetId or {@code null} for none
   */
  public AppendDimensionRequest setSheetId(java.lang.Integer sheetId) {
    this.sheetId = sheetId;
    return this;
  }

  @Override
  public AppendDimensionRequest set(String fieldName, Object value) {
    return (AppendDimensionRequest) super.set(fieldName, value);
  }

  @Override
  public AppendDimensionRequest clone() {
    return (AppendDimensionRequest) super.clone();
  }

}
