/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/googleapis/google-api-java-client-services/
 * Modify at your own risk.
 */

package com.google.api.services.sheets.v4.model;

/**
 * An error in a cell.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Sheets API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ErrorValue extends com.google.api.client.json.GenericJson {

  /**
   * A message with more information about the error (in the spreadsheet's locale).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String message;

  /**
   * The type of error.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * A message with more information about the error (in the spreadsheet's locale).
   * @return value or {@code null} for none
   */
  public java.lang.String getMessage() {
    return message;
  }

  /**
   * A message with more information about the error (in the spreadsheet's locale).
   * @param message message or {@code null} for none
   */
  public ErrorValue setMessage(java.lang.String message) {
    this.message = message;
    return this;
  }

  /**
   * The type of error.
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * The type of error.
   * @param type type or {@code null} for none
   */
  public ErrorValue setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  @Override
  public ErrorValue set(String fieldName, Object value) {
    return (ErrorValue) super.set(fieldName, value);
  }

  @Override
  public ErrorValue clone() {
    return (ErrorValue) super.clone();
  }

}
