/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/googleapis/google-api-java-client-services/
 * Modify at your own risk.
 */

package com.google.api.services.sheets.v4.model;

/**
 * The number format of a cell.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Sheets API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class NumberFormat extends com.google.api.client.json.GenericJson {

  /**
   * Pattern string used for formatting. If not set, a default pattern based on the user's locale
   * will be used if necessary for the given type. See the [Date and Number Formats
   * guide](/sheets/api/guides/formats) for more information about the supported patterns.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String pattern;

  /**
   * The type of the number format. When writing, this field must be set.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * Pattern string used for formatting. If not set, a default pattern based on the user's locale
   * will be used if necessary for the given type. See the [Date and Number Formats
   * guide](/sheets/api/guides/formats) for more information about the supported patterns.
   * @return value or {@code null} for none
   */
  public java.lang.String getPattern() {
    return pattern;
  }

  /**
   * Pattern string used for formatting. If not set, a default pattern based on the user's locale
   * will be used if necessary for the given type. See the [Date and Number Formats
   * guide](/sheets/api/guides/formats) for more information about the supported patterns.
   * @param pattern pattern or {@code null} for none
   */
  public NumberFormat setPattern(java.lang.String pattern) {
    this.pattern = pattern;
    return this;
  }

  /**
   * The type of the number format. When writing, this field must be set.
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * The type of the number format. When writing, this field must be set.
   * @param type type or {@code null} for none
   */
  public NumberFormat setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  @Override
  public NumberFormat set(String fieldName, Object value) {
    return (NumberFormat) super.set(fieldName, value);
  }

  @Override
  public NumberFormat clone() {
    return (NumberFormat) super.clone();
  }

}
