/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/googleapis/google-api-java-client-services/
 * Modify at your own risk.
 */

package com.google.api.services.sheets.v4.model;

/**
 * Represents spreadsheet theme
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Sheets API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class SpreadsheetTheme extends com.google.api.client.json.GenericJson {

  /**
   * Name of the primary font family.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String primaryFontFamily;

  /**
   * The spreadsheet theme color pairs. To update you must provide all theme color pairs.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<ThemeColorPair> themeColors;

  /**
   * Name of the primary font family.
   * @return value or {@code null} for none
   */
  public java.lang.String getPrimaryFontFamily() {
    return primaryFontFamily;
  }

  /**
   * Name of the primary font family.
   * @param primaryFontFamily primaryFontFamily or {@code null} for none
   */
  public SpreadsheetTheme setPrimaryFontFamily(java.lang.String primaryFontFamily) {
    this.primaryFontFamily = primaryFontFamily;
    return this;
  }

  /**
   * The spreadsheet theme color pairs. To update you must provide all theme color pairs.
   * @return value or {@code null} for none
   */
  public java.util.List<ThemeColorPair> getThemeColors() {
    return themeColors;
  }

  /**
   * The spreadsheet theme color pairs. To update you must provide all theme color pairs.
   * @param themeColors themeColors or {@code null} for none
   */
  public SpreadsheetTheme setThemeColors(java.util.List<ThemeColorPair> themeColors) {
    this.themeColors = themeColors;
    return this;
  }

  @Override
  public SpreadsheetTheme set(String fieldName, Object value) {
    return (SpreadsheetTheme) super.set(fieldName, value);
  }

  @Override
  public SpreadsheetTheme clone() {
    return (SpreadsheetTheme) super.clone();
  }

}
